include:
  - template: Auto-DevOps.gitlab-ci.yml

build-config-file:
  image: maven
  stage: .pre

  # only:
  #   refs:
  #     - merge_requests
  #     - sandbox
  #     - stage
  #     - production

  environment:
    name: $CI_COMMIT_REF_NAME
  script:
    - |
      echo "***** FILE and ENVIRONMENT SCOPED REPO VARIABLES *****"
      echo "Building for environment branch: $CI_COMMIT_REF_NAME"
      echo "The value of a masked group varilable was passed to PWD1, whose value is: $PWD1"
      echo "The value of NONSECRETSAMEFORALLENVIRONMENTSVAR1 from $MAVEN_PROJ_DIR/.buildvars.sh is: $NONSECRETSAMEFORALLENVIRONMENTSVAR1"
      echo "The value of VISIBLE_ENV_DATA is $VISIBLE_ENV_DATA"
      echo "The value of GLOBAL_VISIBLE_VAR is $GLOBAL_VISIBLE_VAR"
      echo ""
      echo "***** GROUP INHERITED VARIABLES *****"
      echo "The value of TOP_SCOPE_VAR1 is $TOP_SCOPE_VAR1"
      echo "The value of TOP_SCOPE_VAR2 is $TOP_SCOPE_VAR2"
      echo "The value of TOP_SCOPE_VAR3 is $TOP_SCOPE_VAR3"
      echo "The value of SUBSCOPE_VAR1 is $SUBSCOPE_VAR1"
      echo "The value of SUBSCOPE_VAR2 is $SUBSCOPE_VAR2"
      echo "The value of REPO_SCOPE_VAR1 is $REPO_SCOPE_VAR1"
      echo "If you never want your built config file nor the built java artifact to be"
      echo "captured to artifacts or the runner cache, you must create the config, do the build"
      echo "and upload the artifact to your CD mechanism all in one GitLab job."

      wget https://github.com/sgoeschl/freemarker-cli/releases/download/v2.0.0-BETA-4/freemarker-cli-2.0.0-BETA-4-app.tar.gz
      tar -xf freemarker-cli-2.0.0-BETA-4-app.tar.gz

      ./freemarker-cli-2.0.0-BETA-4/bin/freemarker-cli -t template.config.properties > src/main/java/hello/config.properties | tee src/test/java/hello/config.properties

      echo "showing what is in our configuration file 'src/main/java/hello/config.properties' : "

      cat src/main/java/hello/config.properties

  artifacts:
    paths:
      - src/main/java/hello/config.properties